
;     DEF FN l(f$) : f$=name+$ff
;	(   f   $   0e  0   alo ahi llo lhi )
; iy +  00  01  02  03  04  05  06  07  08
;DEFADD ^

;     DEF FN l(f$)=USR LoadCODE
;     RANDOMIZE FN l(f$)
;     RANDOMIZE USR NoCache
;     RANDOMIZE USR NoMotor

        org  32000

; 4D 00
; 00 00
; 5C 00
; 01 6E
; 4E 6E
; 5D 6E
; 42 7F
; 59 7F
; 6B 7F

        ; table of address offsets (** NOT SAVED)
        ;    location             value
        defb NoCache  - LoadCode, 0  ;}
        defb LoadCODE - LoadCode, 0  ;} called from BASIC
        defb NoMotor  - LoadCode, 0  ;}
        defb LCI-LoadCode+1, PageIn  - LoadCode ;}
        defb NCI-LoadCode+1, PageIn  - LoadCode ;} adjust by offset
        defb NMI-LoadCode+1, PageIn  - LoadCode ;}
        defb LCO-LoadCode+1, PageOut - LoadCode ;}
        defb NCO-LoadCode+1, PageOut - LoadCode ;} adjust by offset
        defb NMO-LoadCode+1, PageOut - LoadCode ;}

LoadCODE: ; saved from here (32022, 146 bytes)
LCI:    call PageIn     ;switch to ROM2(DOS), page 7
        ld   ix,(23563) ;IY=(DEFADD): address of FN l(f$) parameter
        ld   l,(ix+04)
        ld   h,(ix+05)  ;HL=f$ address
        ld   bc,$0301   ;file ID=3, access=read
        ld   de,$0001   ;create=0,  open=1
        call $0106      ;DOS_OPEN
        jr   nc,BASIC   ;if error

        ld   b,3        ;file ID=3
        call $010f      ;DOS_REFHEAD: IX=header address in page 7
        jr   nc,BASIC   ;if error

        ld   b,3        ;file ID=3
        ld   c,(ix+07)  ;page
        ld   l,(ix+03)
        ld   h,(ix+04)  ;HL=load address
        ld   e,(ix+01)
        ld   d,(ix+02)  ;DE=bytes
        call $0112      ;DOS_READ
        jr   nc,BASIC   ;if error

        ld   b,3        ;file ID=3
        call $0109      ;DOS_CLOSE

        ;restore BASIC environment
BASIC:  jr   c,DERROK   ;JPs to DOS will return here
        ;A=0 + Carry=0 is an error; ie. "0 Disk not ready"
        ;so add one to error code
        inc  a
        jr   DERROR
DERROK: xor  a          ;Carry set=OK, reset error code
DERROR: ex   af,af'
LCO:    call PageOut
        ex   af,af'
        ld   iy,$5C3A   ;restore ERR_NR
        ld   b,0
        ld   c,a        ;C =status
        ret             ;return DOS status (+1 if error)

NoCache:  ;
NCI:    call PageIn     ;before loading, set DOS & RAM caches to zero
        ld   de,$0000
        ld   h,d
        ld   l,e
        call $013f      ;DOS_SET1346
NCO:    call PageOut
        ret

NoMotor:  ;
NMI:    call PageIn     ;after loading,
        call $019c      ;DDL_OFFMOTOR
        ld   iy,$5c3a   ;turn off the disk motor
        res  4,(iy+$01) ;and disable the motor timeout check
NMO:    call PageOut
        ret

PageIn: di
       ;ld   a,($5b5c)  ;BANKM (23388)
       ;and  %11101000
       ;or   %00000111
        	defb 0,0
            ld   a,$07
        ld   ($5b5c),a
        	ex   (sp),hl
        ld   bc,$7ffd   ;32765
        out  (c),a      ;switch to ROM2(DOS), page 7
        	nop
        	ex   (sp),hl
        ret

PageOut:di
       ;ld   a,($5b5c)  ;BANKM (23388)
       ;and  %11111000
       ;or   %00010000
        	defb 0,0
            ld   a,$10
        ld   ($5b5c),a
        	ex   (sp),hl
        ld   bc,$7ffd   ;32765
        out  (c),a      ;switch to ROM3(48k), page 0
        	nop
        	ex   (sp),hl
        ei
        reti

; *****